#include <stdio.h>
#include <fcntl.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <string.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/ioctl.h>

#include "ivce_test.h"
#include "ivc_aes.h"

static int rd_test=0;



#define MAX_BOARD_NUM	16

#define UNKNOW_BOARD	0
#define IVCE_C604_R10	1
#define IVCE_C604_R20	2
#define IVCME_C604	3
#define IVCE_C608_R10	4
#define MAX_BOARD_TYPE	4
char type_str[MAX_BOARD_TYPE+1][20]={
"Unknow       ",
"IVCE_C604_R10",
"IVCE_C604_R20",
"IVCME_C604   ",
"IVCE_C608_R10",
};


void listitem(int board) {
	printf("\n");
	printf("--- GPIO FUNCTION ---\n");		
	printf(" 1. VIOCARD Read\n");
	printf(" 2. VIOCARD OUT0 High\n");
	printf(" 3. VIOCARD OUT0 Low\n");
	printf(" 4. VIOCARD OUT1 High\n");
	printf(" 5. VIOCARD OUT1 Low\n");
	printf(" 6. VIOCARD OUT2 High\n");
	printf(" 7. VIOCARD OUT2 Low\n");
	printf(" 8. VIOCARD OUT3 High\n");
	printf(" 9. VIOCARD OUT3 Low\n");	
	if((board == IVCE_C604_R10)||(board == IVCE_C608_R10)||(board == IVCE_C604_R20)) {			
	printf("10. SYSTEM RDY LED High\n");
	printf("11. SYSTEM RDY LED Low\n");	
	printf("12. SYSTEM ERR LED High\n");
	printf("13. SYSTEM ERR LED Low\n");
	printf("14. WDT TOGGLE LED High\n");
	printf("15. WDT TOGGLE LED Low\n");
	}
	printf("--- VIDEO OUT FUNCTION ---\n");
	if(rd_test) {
	if(board == IVCE_C604_R20) {	
	printf("27. VOUT IS NTSC PATTERN(adv7391 color bar)\n");
	printf("28. VOUT IS PAL PATTERN(adv7391 color bar) \n");
	}
	}
	if(board == IVCE_C604_R20) {
	printf("29. VOUT BYPASS NTSC\n");
	printf("30. VOUT BYPASS PAL\n");
	}
	if((board == IVCE_C604_R10)||(board == IVCE_C608_R10)||(board == IVCE_C604_R20)) {		
	printf("31. VI1 BYPASS VO1 \n");
	printf("32. VI2 BYPASS VO1 \n");
	printf("33. VI3 BYPASS VO1 \n");
	printf("34. VI4 BYPASS VO1 \n");
	}
	if((board == IVCE_C604_R10)||(board == IVCE_C608_R10)) {	
	printf("35. VI1 BYPASS VO2 \n");
	printf("36. VI2 BYPASS VO2 \n");	
	printf("37. VI3 BYPASS VO2 \n");
	printf("38. VI4 BYPASS VO2 \n");
	}		

	printf("--- MCU FUNCTION ---\n");
	if((board == IVCE_C604_R10)||(board == IVCE_C608_R10)||(board == IVCE_C604_R20)) {
	printf("51. WDT software toggle test\n");
	printf("52. WDT start\n");
	if(rd_test) {
	printf("53. WDT stop\n");
	}
	printf("54. WDT driver toggle disable (test use ,wait 5 sec,check reset pin)\n");
	if(rd_test) {
	printf("55. WDT driver toggle enable  (test use)\n");	
	}
	}
	printf("58. AES Board Check\n");
	if(board == IVCE_C604_R20) {	
	printf("59. AES company id Check\n");
	}

	printf("--- Main FUNCTION ---\n");
	printf("60. TEST VIDEO \n");
	printf("61. TEST AUDIO \n");
	printf("97. Select Board\n");

	if(rd_test) {	
	printf("98. Find other I2C Devices (test use)\n");
	}					
	printf("99. Exit Program\n");
	printf("Please enter the choice>> ");
}


void do_ioctrl(int fd,int cmd, void *arg,char *str)
{
	int ret=0;
	ret = ioctl(fd, cmd, (int *)arg);
	if (ret == 0) {
		printf("\n %s %p",str,(int *)arg);	
	} else {
		printf("\n %s Not Support CMD",str);
	}
}

struct board_info {
	int number;
	int fd;
	int type;
	int video_start_ch;
	int video_ch_num;
	int board_num;
	char str[255];
	int alsa_hw;
	struct ivce_pci_s pci;
	struct mcu_info_s mcu_info;
};

//************************************************
// get_mcu_info : Get mcu infomation  
//************************************************

void get_mcu_info(struct board_info *board)
{

	memset(&board->mcu_info,0x0,sizeof(struct mcu_info_s));
					
	ioctl(board->fd, IVCE_GET_MCU_INFO, &board->mcu_info);
	printf("[%d] ",board->number);
	if(board->type>MAX_BOARD_TYPE) {
		board->type = UNKNOW_BOARD;
	}
	printf("%s ",type_str[board->type]);
	printf(" ver %d.%d ",board->mcu_info.version,board->mcu_info.reversion);	
			
//	printf(" board_id = %d |",board->mcu_info.board_id);
	printf(" card_id = %2d",board->mcu_info.card_id);

	printf(" video%2d~video%2d",board->video_start_ch,board->video_start_ch+board->video_ch_num-1);
	printf(" alsa = %2d",board->alsa_hw);
	printf("\n");
}


//************************************************
// get_pci_info : Get PCI vendor/device  
//************************************************

void get_board_type(struct board_info *board)
{
	board->type=UNKNOW_BOARD;
	board->video_ch_num=1;	

	if(board->pci.vendor == ICP_VENDOR_ID) {
		if(board->pci.device == IVCE604_DEVICE_ID) {
			board->type=IVCE_C604_R10;
			board->video_ch_num=4;			
		} else if(board->pci.device == IVCE608_DEVICE_ID) {
			board->type=IVCE_C608_R10;
			board->video_ch_num=8;	
		} else if(board->pci.device == IVCE_CX58_DEVICE_ID) {
			if(board->pci.sub_device == IVCME604_SUBDEVICE_ID) {
				board->type=IVCME_C604;
				board->video_ch_num=4;
			} else {
				board->type=IVCE_C604_R20;
				board->video_ch_num=4;					
			}
		} else {
			board->type=UNKNOW_BOARD;
			board->video_ch_num=4;	
		}
	}


}


void get_pci_info(struct board_info *board)
{
	struct cx25821_user_struct arguments = {0, 0, 0, 0x5002C, 0, 0, 0};

	arguments.register_address=RDR_SUSSYSTEM_ID_CFG;
    	if (ioctl (board->fd, READ_PCI_ID, (size_t) &arguments) != -1 ) {
  		board->pci.sub_vendor = arguments.ret & 0x0000FFFF;
  		board->pci.sub_device = (arguments.ret & 0xFFFF0000)>>16;
    	}
	arguments.register_address=RDR_VENDOR_DEVICE_ID_CFG;
    	if (ioctl (board->fd, READ_PCI_ID, (size_t) &arguments) != -1 ) {
  		board->pci.vendor = arguments.ret & 0x0000FFFF;
  		board->pci.device = (arguments.ret & 0xFFFF0000)>>16;
    	}

	DBG("\n device = 0x%x ",board->pci.device);
	DBG(" vendor = 0x%x ",board->pci.vendor);	
	DBG(" sub_device = 0x%x ",board->pci.sub_device);
	DBG(" sub_vendor = 0x%x \n",board->pci.sub_vendor);

	get_board_type(board);

}

void get_pci_info2(struct board_info *board)
{

	memset(&board->pci,0x0,sizeof(struct ivce_pci_s));
    	if (ioctl (board->fd, IVCE_GET_PCI_INFO, (size_t) &board->pci) != -1 ) {

		DBG("\n device = 0x%x ",board->pci.device);
		DBG(" vendor = 0x%x ",board->pci.vendor);	
		DBG(" sub_device = 0x%x ",board->pci.sub_device);
		DBG(" sub_vendor = 0x%x \n",board->pci.sub_vendor);

		get_board_type(board);
	}
}

//************************************************
// find_video : find video device number and alsa hw number
//************************************************

int find_video(struct board_info *board)
{
	FILE *fp,*fp2;
	int cx21_count=0,cx58_count=0,alsa_count=0;
	int i,board_count=0,name,board_num;
	char str[511];
	char buf[511];
	printf("-------- Board List --------\n");
	for(i=0;i<255;) {
		//find video number
		sprintf(str,"/sys/class/video4linux/video%d/name",i);		
		fp = fopen(str, "r");
		DBG("\n open %s %d\n",str,(int)fp);
		if (fp == NULL) {
			break;
		}
		fgets(buf, sizeof(buf),fp);
		fclose(fp);
		DBG("video%2d %s",i,buf);
		sscanf(buf, "cx258%d[%d] video", &name, &board_num);
		DBG("name=%d,board_num=%d",name,board_num);

		//find alsa number
	retry_alsa:
		sprintf(str,"/sys/class/video4linux/video%d/device/sound/card%d/number",i,alsa_count);		
		fp2 = fopen(str, "r");
		DBG("\n open %s %d\n",str,(int)fp2);
		if (fp2 == NULL) {
			alsa_count++;
			goto retry_alsa;
		}
		fclose(fp2);

		DBG("video%2d alsa %d",i,alsa_count);
		board[board_count].alsa_hw = alsa_count;
		alsa_count++;	
		//


		if(name == 21) {
		sprintf(board[board_count].str,"/dev/cx25821-ioctl%d",board_num+1);
		board[board_count].fd = open(board[board_count].str, O_RDWR);
		DBG("\n open %s %d\n",board[board_count].str,board[board_count].fd);
		if(board[board_count].fd < 0) {
			break;
		}
		board[board_count].video_start_ch = i;
		board[board_count].board_num = board_num;	
		board[board_count].type = UNKNOW_BOARD;
    		get_pci_info(&board[board_count]);
		board[board_count].number = board_count;
		get_mcu_info(&board[board_count]);
		i += board[board_count].video_ch_num;		
		board_count++;
		cx21_count++;

		} else if(name==58) {

		sprintf(board[board_count].str,"/dev/cx25858-ioctl%d",board_num);
		board[board_count].fd=open(board[board_count].str, O_RDWR);
		DBG("\n open %s %d",board[board_count].str,board[board_count].fd);
		if(board[board_count].fd < 0) {
			break;
		}
		board[board_count].video_start_ch = i;
		board[board_count].board_num = board_num;	
		board[board_count].type = UNKNOW_BOARD;
    		get_pci_info2(&board[board_count]);
		board[board_count].number = board_count;
		get_mcu_info(&board[board_count]);
		i += board[board_count].video_ch_num;	
		board_count++;
		cx58_count++;
		} else {
			i++;
		}

	}

	if(board_count==0) {
		printf("No Any Board\n");
		return 0;
	}

	return board_count;
}
//************************************************
// preview_test : 
//************************************************
void preview_test(struct board_info *board)
{
	int in_h,balance=0,sel_ch,cmd;
	char norm[2][10]={"NTSC","PAL-DK"};	
	char str[511];

	printf("Preview Video channel 0~%d:",board->video_ch_num-1);
	if (scanf("%d",&cmd)==0) {
		scanf("%*[\n]");
		getchar();
	}

	if(cmd>=board->video_ch_num) {
		printf("Channel %d Error ,max %d\n",cmd,board->video_ch_num);
		return;
	}
		
	sel_ch=cmd;
	printf("0:NTSC 1:PAL:");
	if (scanf("%d",&cmd)==0) {
		scanf("%*[\n]");
		getchar();
	}
	printf("Ctrl-C To Stop\n");
	if(cmd==0) {
		in_h = 480;
	} else {
		in_h = 576;
		cmd=1;
	}
	if(sel_ch%2==0) {
		balance = 0;
	} else {
		balance = 100;
	}
			//sprintf(str,"mplayer -vo x11 -tv driver=v4l2:device=/dev/video%d:input=1:norm=%s:width=720:height=%d:outfmt=yuy2:alsa:adevice=hw.%d,%d:amode=1:audiorate=48000:forceaudio:immediatemode=0:balance=%d tv:///0",board->video_start_ch+sel_ch,norm[cmd],in_h,board->alsa_hw,sel_ch/2,balance);

	sprintf(str,"mplayer -nosound -vo x11 -tv driver=v4l2:device=/dev/video%d:input=1:norm=%s:width=720:height=%d:outfmt=yuy2: tv:///0",board->video_start_ch+sel_ch,norm[cmd],in_h);

	DBG("%s\n",str);
	system(str);

	system("killall mplayer");
	balance=balance;
}

//************************************************
// Main   
//************************************************


int main( int argc, char * argv[] ) 
{
	int rand_value=0;
	struct aes_info_s aes_info={
		.PublicKey = {0,0,0,0},
		.vid1 = {0,0,0,0},
		.vid2 = {0,0,0,0},	
		.cid = {0,0,0,0},	//test		
		.pass = -1,							
		};
	int mode;
	int i,type,ret=0,board_count=0;

	struct board_info board[MAX_BOARD_NUM];
	char str[511];
	struct ivce_gpio_s gpio;
		
	unsigned int cmd,board_sel=0;
	int fd,num;
	//-----------------------	

	if(argc>1) {
		rd_test=1;
	} else {	
		rd_test=0;
	}
	
	printf("\nBuild %s %s\n",__DATE__,__TIME__);

select_board:
	board_count = find_video(board);

	printf("\nSelect Board\n");
	if (scanf("%d",&cmd)==0) { 
		scanf("%*[\n]");
		getchar();
	}
	printf("You Select %d\n",cmd);
	if(cmd > (board_count-1)) {
		printf("Select Board Error\n");
		goto 	select_board;	
	}
	board_sel=cmd;
	type = board[board_sel].type;
	fd = board[board_sel].fd;

	get_mcu_info(&board[board_sel]);

	while(1) {
		switch (type) {
		case IVCE_C604_R10:
		case IVCE_C608_R10:
		case IVCE_C604_R20:										
		case IVCME_C604:				
			listitem(type);
			break;						
		default:
			printf("Board type error type=%d",type);
			return -1;			
		}
			
		if (scanf("%d",&cmd)==0) {
			scanf("%*[\n]");
			getchar();
			continue;
		}

		switch (cmd) {
		//-------------------------------------------------------
		// GPIO
		//--------------------------------------------------------			

		case 1:	// 1.  VIOCARD Read
			if(type != IVCME_C604) {			
			gpio.cmd 	= PIO_GET_CMD;
			gpio.num 	= IO_VIO_CARD_4;
			gpio.value 	= 0;
			if(ioctl(fd, IVCE_GPIO, &gpio) == 0) {
				printf("\n IO_VIO_CARD_4=%d",gpio.value);
			}

			gpio.cmd 	= PIO_GET_CMD;
			gpio.num 	= IO_VIO_CARD_5;
			gpio.value 	= 0;
			if(ioctl(fd, IVCE_GPIO, &gpio) == 0) {
				printf("\n IO_VIO_CARD_5=%d",gpio.value);
			}			
			gpio.cmd 	= PIO_GET_CMD;
			gpio.num 	= IO_VIO_CARD_6;
			gpio.value 	= 0;
			if(ioctl(fd, IVCE_GPIO, &gpio) == 0) {
				printf("\n IO_VIO_CARD_6=%d",gpio.value);						
			}
			gpio.cmd 	= PIO_GET_CMD;
			gpio.num 	= IO_VIO_CARD_7;
			gpio.value 	= 0;
			if(ioctl(fd, IVCE_GPIO, &gpio ) == 0) {
				printf("\n IO_VIO_CARD_7=%d",gpio.value);	
			}
			} else {

			gpio.cmd 	= PIO_GET_CMD;
			gpio.num 	= IO_VIO_CARD_0;
			gpio.value 	= 0;
			if(ioctl(fd, IVCE_GPIO, &gpio) == 0) {
				printf("\n IO_VIO_CARD_0=%d",gpio.value);
			}			
			gpio.cmd 	= PIO_GET_CMD;
			gpio.num 	= IO_VIO_CARD_1;
			gpio.value 	= 0;
			if(ioctl(fd, IVCE_GPIO, &gpio) == 0) {
				printf("\n IO_VIO_CARD_1=%d",gpio.value);
			}			
			gpio.cmd 	= PIO_GET_CMD;
			gpio.num 	= IO_VIO_CARD_2;
			gpio.value 	= 0;
			if(ioctl(fd, IVCE_GPIO, &gpio) == 0) {
				printf("\n IO_VIO_CARD_2=%d",gpio.value);						
			}
			gpio.cmd 	= PIO_GET_CMD;
			gpio.num 	= IO_VIO_CARD_3;
			gpio.value 	= 0;
			if(ioctl(fd, IVCE_GPIO, &gpio) == 0) {
				printf("\n IO_VIO_CARD_3=%d",gpio.value);	
			}
			}								
			break;
		case 2:	//2.  VIOCARD OUT0 High
			if(type != IVCME_C604) {
			gpio.num 	= IO_VIO_CARD_0;
			gpio.cmd 	= PIO_SET_CMD;
			gpio.value 	= 1;
			ioctl(fd, IVCE_GPIO, &gpio);
			printf("\n IO_VIO_CARD_0=%d",gpio.value);
			} else {
			gpio.num 	= IO_VIO_CARD_4;
			gpio.cmd 	= PIO_SET_CMD;
			gpio.value 	= 1;
			ioctl(fd, IVCE_GPIO, &gpio);
			printf("\n IO_VIO_CARD_4=%d",gpio.value);
			}
			break;
		case 3: //3.  VIOCARD OUT0 Low
			if(type != IVCME_C604) {
			gpio.cmd 	= PIO_SET_CMD;
			gpio.num 	= IO_VIO_CARD_0;
			gpio.value 	= 0;
			ioctl(fd, IVCE_GPIO, &gpio);
			printf("\n IO_VIO_CARD_0=%d",gpio.value);
			} else {
			gpio.cmd 	= PIO_SET_CMD;
			gpio.num 	= IO_VIO_CARD_4;
			gpio.value 	= 0;
			ioctl(fd, IVCE_GPIO, &gpio);
			printf("\n IO_VIO_CARD_4=%d",gpio.value);
			}
			break;
		case 4: //4.  VIOCARD OUT1 High
			if(type != IVCME_C604) {
			gpio.cmd 	= PIO_SET_CMD;
			gpio.num 	= IO_VIO_CARD_1;
			gpio.value 	= 1;
			ioctl(fd, IVCE_GPIO, &gpio);
			printf("\n IO_VIO_CARD_1=%d",gpio.value);
			} else {
			gpio.cmd 	= PIO_SET_CMD;
			gpio.num 	= IO_VIO_CARD_5;
			gpio.value 	= 1;
			ioctl(fd, IVCE_GPIO, &gpio);
			printf("\n IO_VIO_CARD_5=%d",gpio.value);
			}
			break;
		case 5: //5.  VIOCARD OUT1 Low
			if(type != IVCME_C604) {
			gpio.cmd 	= PIO_SET_CMD;
			gpio.num 	= IO_VIO_CARD_1;
			gpio.value 	= 0;
			ioctl(fd, IVCE_GPIO, &gpio);
			printf("\n IO_VIO_CARD_1=%d",gpio.value);
			} else {
			gpio.cmd 	= PIO_SET_CMD;
			gpio.num 	= IO_VIO_CARD_5;
			gpio.value 	= 0;
			ioctl(fd, IVCE_GPIO, &gpio);
			printf("\n IO_VIO_CARD_5=%d",gpio.value);
			}
			break;
		case 6: //6.  VIOCARD OUT2 High
			if(type != IVCME_C604) {
			gpio.cmd 	= PIO_SET_CMD;
			gpio.num 	= IO_VIO_CARD_2;
			gpio.value 	= 1;
			ioctl(fd, IVCE_GPIO, &gpio);
			printf("\n IO_VIO_CARD_2=%d",gpio.value);
			} else {
			gpio.cmd 	= PIO_SET_CMD;
			gpio.num 	= IO_VIO_CARD_6;
			gpio.value 	= 1;
			ioctl(fd, IVCE_GPIO, &gpio);
			printf("\n IO_VIO_CARD_6=%d",gpio.value);
			}
			break;
		case 7:
			if(type != IVCME_C604) {
			gpio.cmd 	= PIO_SET_CMD;
			gpio.num 	= IO_VIO_CARD_2;
			gpio.value 	= 0;
			ioctl(fd, IVCE_GPIO, &gpio);
			printf("\n IO_VIO_CARD_2=%d",gpio.value);
			} else {
			gpio.cmd 	= PIO_SET_CMD;
			gpio.num 	= IO_VIO_CARD_6;
			gpio.value 	= 0;
			ioctl(fd, IVCE_GPIO, &gpio);
			printf("\n IO_VIO_CARD_6=%d",gpio.value);
			}
			break;
		case 8:
			if(type != IVCME_C604) {
			gpio.cmd 	= PIO_SET_CMD;
			gpio.num 	= IO_VIO_CARD_3;
			gpio.value 	= 1;
			ioctl(fd, IVCE_GPIO, &gpio);
			printf("\n IO_VIO_CARD_3=%d",gpio.value);
			} else {
			gpio.cmd 	= PIO_SET_CMD;
			gpio.num 	= IO_VIO_CARD_7;
			gpio.value 	= 1;
			ioctl(fd, IVCE_GPIO, &gpio);
			printf("\n IO_VIO_CARD_7=%d",gpio.value);
			}
			break;
		case 9:
			if(type != IVCME_C604) {
			gpio.cmd 	= PIO_SET_CMD;
			gpio.num 	= IO_VIO_CARD_3;
			gpio.value 	= 0;
			ioctl(fd, IVCE_GPIO, &gpio);
			printf("\n IO_VIO_CARD_3=%d",gpio.value);
			} else {
			gpio.cmd 	= PIO_SET_CMD;
			gpio.num 	= IO_VIO_CARD_7;
			gpio.value 	= 0;
			ioctl(fd, IVCE_GPIO, &gpio);
			printf("\n IO_VIO_CARD_7=%d",gpio.value);
			}
			break;			
		case 10:
			if(type != IVCME_C604) {
			gpio.cmd 	= PIO_SET_CMD;
			gpio.num 	= IO_SYS_RDY;
			gpio.value 	= 0;
			ioctl(fd, IVCE_GPIO, &gpio);
			printf("\n IO_SYS_RDY=%d",gpio.value);
			}
			break;
		case 11:
			if(type != IVCME_C604) {
			gpio.cmd 	= PIO_SET_CMD;
			gpio.num 	= IO_SYS_RDY;
			gpio.value 	= 1;
			ioctl(fd, IVCE_GPIO, &gpio);
			printf("\n IO_SYS_RDY=%d",gpio.value);
			}
			break;				
		case 12:
			if(type != IVCME_C604) {
			gpio.cmd 	= PIO_SET_CMD;
			gpio.num 	= IO_SYS_ERR;
			gpio.value 	= 0;
			ioctl(fd, IVCE_GPIO, &gpio);
			printf("\n IO_SYS_ERR=%d",gpio.value);
			}
			break;
		case 13:
			gpio.cmd 	= PIO_SET_CMD;
			gpio.num 	= IO_SYS_ERR;
			gpio.value 	= 1;
			ioctl(fd, IVCE_GPIO, &gpio);
			printf("\n IO_SYS_ERR=%d",gpio.value);
			break;
		case 14:
			gpio.cmd 	= PIO_SET_CMD;
			gpio.num 	= IO_WDT_TOG;
			gpio.value 	= 0;
			ioctl(fd, IVCE_GPIO, &gpio);
			printf("\n IO_WDT_TOG=%d",gpio.value);
			break;
		case 15:
			if(type != IVCME_C604) {
			gpio.cmd 	= PIO_SET_CMD;
			gpio.num 	= IO_WDT_TOG;
			gpio.value 	= 1;
			ioctl(fd, IVCE_GPIO, &gpio);
			printf("\n IO_WDT_TOG=%d",gpio.value);
			}
			break;	
		//-------------------------------------------------------
		// VOUT
		//--------------------------------------------------------	
//	if(type != IVCE_C604_R10) {	//ivce_c604r10 not support video out	
		case 27:
			cmd = STD_NTSC;		
			ret = ioctl(fd, A_IOCTL_SET_VID_STD, &cmd);
			do_ioctrl(fd, A_IOCTL_SET_VID_STD, &cmd,"SET STD_NTSC");				
			cmd = VOUT_NTSC_PATTERN;		
			goto set_vout_format;
		case 28:
			cmd = STD_PAL;
			do_ioctrl(fd, A_IOCTL_SET_VID_STD, &cmd,"SET STD_PAL");									
			cmd = VOUT_PAL_PATTERN;
			goto set_vout_format;						
		case 29:
			cmd = STD_NTSC;		
			do_ioctrl(fd, A_IOCTL_SET_VID_STD, &cmd,"SET STD_NTSC");			
			cmd = VOUT_NTSC;		
			goto set_vout_format;
		case 30:
			cmd = STD_PAL;
			do_ioctrl(fd, A_IOCTL_SET_VID_STD, &cmd,"SET STD_PAL");									
			cmd = VOUT_PAL;
		set_vout_format:			
			do_ioctrl(fd, A_IOCTL_SET_VID_STD, &cmd,"set_vout_format");
			break;				
		case 31:
		case 32:
		case 33:
		case 34:						
			cmd -= 31;	//ch0~3 cmd=0~3		
			ioctl(fd, IVCE_BYPASS_VOUT1, &cmd);
			printf("\n IVCE_BYPASS_VOUT1 CH%d",cmd);
			break;						
		case 35:
		case 36:
		case 37:
		case 38:						
			cmd -= 35;	//ch0~3 cmd=0~3			
			ret = ioctl(fd, IVCE_BYPASS_VOUT2, &cmd);
			if (ret == 0) {
				printf("\n IVCE_BYPASS_VOUT2 CH%d",cmd);
			} else {
				printf("\n Not Support CMD");
			}
			break;

		case 40:
			cmd = STD_NTSC;		
			ret = ioctl(fd, A_IOCTL_SET_VID_STD, &cmd);
			printf("\n IVCE_VOUT_FORMAT %d",cmd);
			break;	
		case 41:		
			cmd = VOUT_NTSC;		
			goto set_vout_format;
//	}

		case 60:
			preview_test(&board[board_sel]);
			break;
		case 61:
			printf("Play Audio channel 0~%d:",board[board_sel].video_ch_num-1);
			if (scanf("%d",&cmd)==0) {
				scanf("%*[\n]");
				getchar();
			}
			if(cmd>=board[board_sel].video_ch_num) {
				printf("Channel %d Error ,max %d\n",cmd,board[board_sel].video_ch_num);
				break;
			}
		
			printf("Ctrl-C To Stop\n");
			sprintf(str,"arecord -r 48000 -c 2 -f S16_LE -D hw:%d,%d | aplay",board[board_sel].alsa_hw,cmd/2);	
			DBG("%s\n",str);
			system(str);

			system("killall aplay");
			system("killall arecord");
			break; 

		//-------------------------------------------------------
		// WDT
		//--------------------------------------------------------
		case 51:
			if(type != IVCME_C604) {

			cmd = PIO_WDT_EN;
			ioctl(fd, IVCE_WDT, &cmd);
			printf("\n PIO_WDT_EN");

			gpio.cmd 	= PIO_SET_CMD;
			gpio.num 	= IO_WDT_TOG;
			cmd = PIO_WDT_DIS_DRIVER_TOGGLE;		
			ioctl(fd, IVCE_WDT, &cmd);
			printf("\n PIO_WDT_DIS_DRIVER_TOGGLE");

			printf("\n check reset pin\n");			
			for(i=0;i<10;i++) {	//toggle time min 1 sec
				sleep(1);
				gpio.value 	= 0;
				ioctl(fd, IVCE_GPIO, &gpio);
				printf("\n IO_WDT_TOG=%d",gpio.value);
				sleep(1);
				gpio.value 	= 1;
				ioctl(fd, IVCE_GPIO, &gpio);
				printf("\n IO_WDT_TOG=%d",gpio.value);

			}
			printf("\n software not toggle wdt,Wait ...reset\n");
			sleep(10);
			}
			break;

		case 52:
			if(type != IVCME_C604) {
			cmd = PIO_WDT_EN;
			ioctl(fd, IVCE_WDT, &cmd);
			printf("\n PIO_WDT_EN");
			}
			break;
		case 53:
			if(type != IVCME_C604) {
			cmd = PIO_WDT_DIS;		
			ioctl(fd, IVCE_WDT, &cmd);
			printf("\n PIO_WDT_DIS");
			}
			break;				
		case 54:
			if(type != IVCME_C604) {
			cmd = PIO_WDT_DIS_DRIVER_TOGGLE;		
			ioctl(fd, IVCE_WDT, &cmd);
			printf("\n PIO_WDT_DIS_DRIVER_TOGGLE");
			}
			break;
		case 55:
			if(type != IVCME_C604) {
			cmd = PIO_WDT_EN_DRIVER_TOGGLE;		
			ioctl(fd, IVCE_WDT, &cmd);
			printf("\n PIO_WDT_EN_DRIVER_TOGGLE");
			}
			break;	
		//-------------------------------------------------------
		// AES
		//--------------------------------------------------------
		case 58:
			printf("\n - AES SOFTWARE VERSION=%d",ivcx_aes_version());

			mode = AES_MODE_GET_VID2;					

			rand_value = rand();
			aes_info.PublicKey[0] = rand_value&0xff;
			aes_info.PublicKey[1] = (rand_value>>8)&0xff;
			aes_info.PublicKey[2] = (rand_value>>16)&0xff;
			aes_info.PublicKey[3] = (rand_value>>24)&0xff;			
			rand_value = rand();
			aes_info.vid1[0] = rand_value&0xff;
			aes_info.vid1[1] = (rand_value>>8)&0xff;
			aes_info.vid1[2] = (rand_value>>16)&0xff;
			aes_info.vid1[3] = (rand_value>>24)&0xff;
			rand_value = rand();
			aes_info.vid2[0] = rand_value&0xff;
			aes_info.vid2[1] = (rand_value>>8)&0xff;
			aes_info.vid2[2] = (rand_value>>16)&0xff;
			aes_info.vid2[3] = (rand_value>>24)&0xff;									

			DBG("\n - PublicKey:	%x %x %x %x",aes_info.PublicKey[0],aes_info.PublicKey[1],aes_info.PublicKey[2],aes_info.PublicKey[3]);
			DBG("\n - vid1 :	%x %x %x %x",aes_info.vid1[0],aes_info.vid1[1],aes_info.vid1[2],aes_info.vid1[3]);
			DBG("\n - vid2 :	%x %x %x %x",aes_info.vid2[0],aes_info.vid2[1],aes_info.vid2[2],aes_info.vid2[3]);

			ret = ivcx_ap_aes_check(fd,mode,&aes_info);
			
			if(ret==0) {
				if(aes_info.pass == AES_PASS) {
					printf("\n - AES pass %d",aes_info.pass);
				} else {
					printf("\n - AES error %d",aes_info.pass);			
				}
			} else {
				printf("\n - ivcx_ap_aes_check error %d",ret);
			}
			

			break;			
		case 59:
			if ((board[board_sel].mcu_info.version >= 1) && (board[board_sel].mcu_info.reversion >=7) == 0) {
				printf("\n mcu version %d.%d not support AES company id Check,",board[board_sel].mcu_info.version,board[board_sel].mcu_info.reversion);
				break;
			}
	
			printf("\n - AES SOFTWARE VERSION=%d",ivcx_aes_version());

			if(type != IVCME_C604) {
				mode = AES_MODE_GET_CID;
				printf("\nplease input company id ****:");

				if (scanf("%d",&cmd)==0) {
					scanf("%*[\n]");
					getchar();
				}
				aes_info.cid[3]=cmd%10;
				cmd/=10;
				aes_info.cid[2]=cmd%10;
				cmd/=10;
				aes_info.cid[1]=cmd%10;
				cmd/=10;
				aes_info.cid[0]=cmd%10;
			
				printf("\n - cid:	%d %d %d %d",aes_info.cid[0],aes_info.cid[1],aes_info.cid[2],aes_info.cid[3]);	

			} else {
				mode = AES_MODE_GET_VID2;
			}					

			rand_value = rand();
			aes_info.PublicKey[0] = rand_value&0xff;
			aes_info.PublicKey[1] = (rand_value>>8)&0xff;
			aes_info.PublicKey[2] = (rand_value>>16)&0xff;
			aes_info.PublicKey[3] = (rand_value>>24)&0xff;			
			rand_value = rand();
			aes_info.vid1[0] = rand_value&0xff;
			aes_info.vid1[1] = (rand_value>>8)&0xff;
			aes_info.vid1[2] = (rand_value>>16)&0xff;
			aes_info.vid1[3] = (rand_value>>24)&0xff;
			rand_value = rand();
			aes_info.vid2[0] = rand_value&0xff;
			aes_info.vid2[1] = (rand_value>>8)&0xff;
			aes_info.vid2[2] = (rand_value>>16)&0xff;
			aes_info.vid2[3] = (rand_value>>24)&0xff;									

			DBG("\n - PublicKey:	%x %x %x %x",aes_info.PublicKey[0],aes_info.PublicKey[1],aes_info.PublicKey[2],aes_info.PublicKey[3]);
			DBG("\n - vid1 :	%x %x %x %x",aes_info.vid1[0],aes_info.vid1[1],aes_info.vid1[2],aes_info.vid1[3]);
			DBG("\n - vid2 :	%x %x %x %x",aes_info.vid2[0],aes_info.vid2[1],aes_info.vid2[2],aes_info.vid2[3]);

			ret = ivcx_ap_aes_check(fd,mode,&aes_info);
			
			if(ret==0) {
				if(aes_info.pass == AES_PASS) {
					printf("\n - AES pass %d",aes_info.pass);
				} else {
					printf("\n - AES error %d",aes_info.pass);			
				}
			} else {
				printf("\n - ivcx_ap_aes_check error %d",ret);
			}
			
			
			break;	
		//-------------------------------------------------------
		// OTHER
		//--------------------------------------------------------																						

		case 97:
			for(i=0;i<board_count;i++) {
				printf("[%d] ",i);
				printf(" MCU FW version = %d |",board[i].mcu_info.version);
				printf(" reversion = %d |",board[i].mcu_info.reversion);	
			
				printf(" board_id = %d |",board[i].mcu_info.board_id);
				printf(" card_id = %d\n",board[i].mcu_info.card_id);	
			}
			goto select_board;
			break;	

		case 98:
			if(type != IVCME_C604) {		
			ioctl(fd, IVCE_POLL_I2C, &num);			
			printf("find %d i2c devices\n",num);	
			}		
			break;								
		case 99:
			close(fd);
			exit(0);
			break;
		default:
			break;
		}
	}

	return 0;
}
